<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	xmlns:beans="http://www.springframework.org/schema/beans"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	version="2.0">
<import href="functions/SeafPersistenceBusinessFunctions.xsl" />
<output method="xml" indent="yes" />

<param name="merged-file-name" />
<variable name="merged-persistence-file" select="document($merged-file-name)" />

<template match="/">
	<element name="beans" namespace="http://www.springframework.org/schema/beans">
		<namespace name="xsi">http://www.w3.org/2001/XMLSchema-instance</namespace>
		<attribute name="xsi:schemaLocation">
			<text>http://www.springframework.org/schema/beans </text>
			<text>http://www.springframework.org/schema/beans/spring-beans-2.5.xsd</text>
		</attribute>
		<attribute name="default-autowire">byType</attribute>
		<element name="bean" namespace="http://www.springframework.org/schema/beans">
			<attribute name="id">hibernateCriteriaBuilder</attribute>
			<attribute name="class">net.sf.seaf.persistence.hibernate.HibernateCriteriaBuilder</attribute>
		</element>
		<apply-templates select="$merged-persistence-file//per:persistence/per:entity" />
	</element>
</template>

<template match="per:entity" >
	<comment><text> </text><value-of select="@name" /><text> </text></comment>
	<text>
   </text>
	<call-template name="per:spring-bean-definition-template">
		<with-param name="id-class" select="per:dao-full-type(.)" />
		<with-param name="class" select="per:hibernate-dao-full-type(.)" />
	</call-template>
	<call-template name="per:spring-bean-definition-template">
		<with-param name="id-class" select="per:controller-full-type(.)" />
		<with-param name="class" select="per:controller-impl-full-type(.)" />
	</call-template>
</template>

<template name="per:spring-bean-definition-template">
	<param name="id-class" as="xs:string" />
	<param name="class" as="xs:string" />
	<element name="bean" namespace="http://www.springframework.org/schema/beans">
		<attribute name="id">
			<value-of select="seaf:first-lower(seaf:type-class($id-class))" />
		</attribute>
		<attribute name="class">
			<value-of select="$class" />
		</attribute>
	</element>
</template>

</stylesheet>
